function [xs, is, r_new, p] = conjgrad_1( Afunc, b, x0, maxiters, miniters, Mdiag)
cgtol = 0.001*norm(b);
is = [];
xs = {};
%r = Afunc(x0) - b;
r = - b;
y = r./Mdiag;

p = -y;
x = x0;

for i = 1:maxiters
    % stopping condition
    if  ( norm(r) <= cgtol)
        break;
    end
    %compute the matrix-vector product.  This is where 95% of the work in
    %HF lies:
    Ap = Afunc(p);
    
    pAp = p'*Ap;

    %the Gauss-Newton matrix should never have negative curvature.  The
    %Hessian easily could unless your objective is convex
    if pAp <= 0
        disp('Negative Curvature!');
        
        disp('Bailing...');
        break;
    end
    
    alpha = (r'*y)/pAp;
    
    x = x + alpha*p;
    r_new = r + alpha*Ap;
    
    y_new = r_new./Mdiag;
    beta = (r_new'*y_new)/(r'*y);
    
    p = -y_new + beta*p;

    r = r_new;
    y = y_new;

end

r_new = r +b;
is(end+1) = i;
xs{end+1} = x;
